#' Plot United Nations Migrant Stock Data
#'
#' @param x A data frame or data table generated by \code{unstock17()}, using \code{wide = FALSE}.
#' @param ... List of arguments passed to default plotting device:
#' \describe{
#' \item{country}{Character string of length one indicating ISO3 character code for country of 
#' interest. Defaults to \code{"USA"}.}
#' \item{yr}{Numeric value indicating the year of interst. Defaults to \code{max(x)}.} 
#' \item{mode}{A character string indicating plot mode. May be either \code{'time series'} (default),
#' which illustrates annual stocks in migrant populations or \code{'static'} which plots a single year. 
#' Default mode is \code{'time series'}.}
#' }
#' @return Returns a plotting device of class \code{ggplot()}.
#' @export
#'
plot.unstocks17<-function(x, ...){

  args <- list(...)
  country <- ifelse(is.null(args$country), 'USA', args$country)
  yr<-ifelse(is.null(args$yr), max(x$year), args$yr)
  mode<-ifelse(is.null(args$mode), 'time series', args$mode)
  
  if(mode=='time series'){
    stock.countries<-x[host_iso==country & year==max(year)][order(-value)][1:5][value>0,as.character(stock)]
    dat<-x[host_iso==country & stock %in% stock.countries]
    dat$stock <- factor(dat$stock, levels = stock.countries)

    plot<-ggplot2::ggplot(dat, ggplot2::aes(x=year, y=value, group=stock))+
      ggplot2::geom_line(ggplot2::aes(color=stock), size=line.size, alpha=line.alpha)+
      ggplot2::geom_point(ggplot2::aes(color=stock), size=point.size, alpha=point.alpha)+
      ggplot2::labs(title=paste('Migrant Stock Populations in',dat$host[1],sep=' '),
           subtitle = paste('For The Top',length(unique(levels(dat$stock))),'Stock Populations During',min(dat$year),'-',max(dat$year), sep = ' '),
           x='',
           y='')+
      ggplot2::scale_color_manual(values=palette[1:length(unique(dat$stock))],
                        name='')+
      ggplot2::scale_y_continuous(labels=scales::comma)+
      ggplot2::scale_x_continuous(breaks=seq(1990,2017,5))+
      ggplot2::theme_minimal()
  }

  if(mode=='static'){
  dat<-x[host_iso==country & year==yr][order(-value)][1:8][value>0]
  dat$stock <- factor(dat$stock, levels = dat$stock[order(-dat$value)])

  plot<-ggplot2::ggplot(dat, ggplot2::aes(x=stock, y=value))+
    ggplot2::geom_bar(stat="identity", fill=palette[1])+
    ggplot2::labs(title=paste('Migrant Stock Populations in',dat$host[1],sep=' '),
         subtitle = paste('For The Top',nrow(dat),'Stock Populations During', yr, sep = ' '),
         x='Origin Country',
         y='')+
    ggplot2::scale_y_continuous(labels=scales::comma)+
    ggplot2::theme_minimal()
  }

  print(plot)
  return(plot)
}
